import java.io.*;
import java.util.*;
import java.awt.*;

public class ObjectCloner
{

   // so that nobody can accidentally create an ObjectCloner object
   private ObjectCloner(){}

   // returns a deep copy of an object
   static public Object deepCopy(Object oldObj) throws Exception
   {

      ObjectOutputStream oos = null;
      ObjectInputStream ois = null;

      try
      {

         // out
         ByteArrayOutputStream bos = 
               new ByteArrayOutputStream(); // A
         oos = new ObjectOutputStream(bos); // B

         // serialize and pass the object out
         oos.writeObject(oldObj);   // C
         oos.flush();               // D

         // in
         ByteArrayInputStream bin = 
               new ByteArrayInputStream(bos.toByteArray()); // E
         ois = new ObjectInputStream(bin);                  // F

         // read in and return the new object
         return ois.readObject(); // G

      }
      catch(Exception e)
      {
         System.out.println("Exception in ObjectCloner = " + e);
         throw(e);
      }
      finally
      {
         oos.close();
         ois.close();
      }

   }

}
